# coding: utf-8

"""
    Rapidata.Dataset

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
import pprint
from pydantic import BaseModel, ConfigDict, Field, StrictStr, ValidationError, field_validator
from typing import Any, List, Optional
from rapidata.api_client.models.naive_referee_config import NaiveRefereeConfig
from rapidata.api_client.models.never_ending_referee_config import NeverEndingRefereeConfig
from rapidata.api_client.models.probabilistic_attach_category_referee_config import ProbabilisticAttachCategoryRefereeConfig
from pydantic import StrictStr, Field
from typing import Union, List, Set, Optional, Dict
from typing_extensions import Literal, Self

COMPAREWORKFLOWMODEL1REFEREE_ONE_OF_SCHEMAS = ["NaiveRefereeConfig", "NeverEndingRefereeConfig", "ProbabilisticAttachCategoryRefereeConfig"]

class CompareWorkflowModel1Referee(BaseModel):
    """
    CompareWorkflowModel1Referee
    """
    # data type: NaiveRefereeConfig
    oneof_schema_1_validator: Optional[NaiveRefereeConfig] = None
    # data type: NeverEndingRefereeConfig
    oneof_schema_2_validator: Optional[NeverEndingRefereeConfig] = None
    # data type: ProbabilisticAttachCategoryRefereeConfig
    oneof_schema_3_validator: Optional[ProbabilisticAttachCategoryRefereeConfig] = None
    actual_instance: Optional[Union[NaiveRefereeConfig, NeverEndingRefereeConfig, ProbabilisticAttachCategoryRefereeConfig]] = None
    one_of_schemas: Set[str] = { "NaiveRefereeConfig", "NeverEndingRefereeConfig", "ProbabilisticAttachCategoryRefereeConfig" }

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )


    discriminator_value_class_map: Dict[str, str] = {
    }

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = CompareWorkflowModel1Referee.model_construct()
        error_messages = []
        match = 0
        # validate data type: NaiveRefereeConfig
        if not isinstance(v, NaiveRefereeConfig):
            error_messages.append(f"Error! Input type `{type(v)}` is not `NaiveRefereeConfig`")
        else:
            match += 1
        # validate data type: NeverEndingRefereeConfig
        if not isinstance(v, NeverEndingRefereeConfig):
            error_messages.append(f"Error! Input type `{type(v)}` is not `NeverEndingRefereeConfig`")
        else:
            match += 1
        # validate data type: ProbabilisticAttachCategoryRefereeConfig
        if not isinstance(v, ProbabilisticAttachCategoryRefereeConfig):
            error_messages.append(f"Error! Input type `{type(v)}` is not `ProbabilisticAttachCategoryRefereeConfig`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in CompareWorkflowModel1Referee with oneOf schemas: NaiveRefereeConfig, NeverEndingRefereeConfig, ProbabilisticAttachCategoryRefereeConfig. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in CompareWorkflowModel1Referee with oneOf schemas: NaiveRefereeConfig, NeverEndingRefereeConfig, ProbabilisticAttachCategoryRefereeConfig. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # deserialize data into NaiveRefereeConfig
        try:
            instance.actual_instance = NaiveRefereeConfig.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into NeverEndingRefereeConfig
        try:
            instance.actual_instance = NeverEndingRefereeConfig.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into ProbabilisticAttachCategoryRefereeConfig
        try:
            instance.actual_instance = ProbabilisticAttachCategoryRefereeConfig.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into CompareWorkflowModel1Referee with oneOf schemas: NaiveRefereeConfig, NeverEndingRefereeConfig, ProbabilisticAttachCategoryRefereeConfig. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into CompareWorkflowModel1Referee with oneOf schemas: NaiveRefereeConfig, NeverEndingRefereeConfig, ProbabilisticAttachCategoryRefereeConfig. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], NaiveRefereeConfig, NeverEndingRefereeConfig, ProbabilisticAttachCategoryRefereeConfig]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())


