# coding: utf-8

"""
    Rapidata.Dataset

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from rapidata.api_client.models.get_workflow_progress_result import GetWorkflowProgressResult
from rapidata.api_client.models.ranked_datapoint_model import RankedDatapointModel
from typing import Optional, Set
from typing_extensions import Self

class GetCompareWorkflowResultOverviewResult(BaseModel):
    """
    GetCompareWorkflowResultOverviewResult
    """ # noqa: E501
    state: StrictStr
    progress: GetWorkflowProgressResult
    top: List[RankedDatapointModel]
    bottom: List[RankedDatapointModel]
    hidden_count: StrictInt = Field(alias="hiddenCount")
    result_type: Optional[StrictStr] = Field(default=None, alias="resultType")
    __properties: ClassVar[List[str]] = ["state", "progress", "top", "bottom", "hiddenCount", "resultType"]

    @field_validator('state')
    def state_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['Created', 'Started', 'Labeling', 'Paused', 'Done', 'Failed']):
            raise ValueError("must be one of enum values ('Created', 'Started', 'Labeling', 'Paused', 'Done', 'Failed')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GetCompareWorkflowResultOverviewResult from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * OpenAPI `readOnly` fields are excluded.
        """
        excluded_fields: Set[str] = set([
            "result_type",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of progress
        if self.progress:
            _dict['progress'] = self.progress.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in top (list)
        _items = []
        if self.top:
            for _item_top in self.top:
                if _item_top:
                    _items.append(_item_top.to_dict())
            _dict['top'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in bottom (list)
        _items = []
        if self.bottom:
            for _item_bottom in self.bottom:
                if _item_bottom:
                    _items.append(_item_bottom.to_dict())
            _dict['bottom'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GetCompareWorkflowResultOverviewResult from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "state": obj.get("state"),
            "progress": GetWorkflowProgressResult.from_dict(obj["progress"]) if obj.get("progress") is not None else None,
            "top": [RankedDatapointModel.from_dict(_item) for _item in obj["top"]] if obj.get("top") is not None else None,
            "bottom": [RankedDatapointModel.from_dict(_item) for _item in obj["bottom"]] if obj.get("bottom") is not None else None,
            "hiddenCount": obj.get("hiddenCount"),
            "resultType": obj.get("resultType")
        })
        return _obj


